!=========================================================================
! Copyright (C) GemTalk Systems 1986-2015.  All Rights Reserved.
!
! $Id: object2.gs,v 1.7 2008-01-09 19:02:35 stever Exp $
!
! Methods from Object for which source will be stripped
! (No longer striping any source)
!
! Superclass Hierarchy:
!   Object.
!
!=========================================================================
 
! do not remove methods

! BUGFIX 27184: methods _abortAndReplay: and _refreshAfterCommitFailure
!               moved to object.gs

category: 'Private'
classmethod: Object
_strippedMethodSelectors
 
"Returns all the method selectors whose source will be stripped when the
 repository is built.  The result consists of two subarrays: the instance method
 selectors and the class method selectors."
 
" do not want subclasses to inherit this list "
self ~~ Object
  ifTrue: [
    ^ self _stripAllMethodSources
      ifTrue: [ self _allStrippedMethodSelectors ]
      ifFalse: [ self _noStrippedMethodSelectors ]
  ].
 
^ #( " instance methods "
    #( )
 
     " class methods "
    #( )
  )
%

